/*
 ******************************* Creazione file *******************************
 *-------------------------------------|--------------------------------------*
 * Creatore : Marco Savegnago					Data di creazione : 30/03/2000
 * Codice   :
 *
 * Note:
 *
 *
 ******************************* Revisione file *******************************
 *-------------------------------------|--------------------------------------*
 * Revisore :                                  Data di revisione :
 * Versione : 0
 *
 * Note:
 *
 */


#ifndef __NTPCFOMDriver_h__
#define __NTPCFOMDriver_h__
   
#define EOL "\n"

class	NTPCFOMDevice;

class NTPCFOMDriver 
: 
	public KDriver
{
	SAFE_DESTRUCTORS
public:
	// Member functions

#if	!_WDM_
	virtual  VOID Unload(VOID);
	DRVMEMBER_SYSCFGCALLBACK	(NTPCFOMDriver , OnConfigure)

#endif	//	_WDM_

	virtual  NTSTATUS DriverEntry(PUNICODE_STRING RegistryPath);
	void	 LoadRegistryParameters(KRegistryKey &Params);

#if	_WDM_
	virtual	NTSTATUS	AddDevice(PDEVICE_OBJECT	Pdo);
#endif	

	// Member data
	// The following data members are loaded from the registry during DriverEntry
	ULONG m_bBreakOnEntry;
	

#if _COMMENT_ONLY
    The following member functions are actually defined by macros.
    These comment-only definitions are for easier Studio navigation.
   ;
#endif

#if	_WDM_
	int	m_Unit;
#else

//	NTPCFOMDevice*	p_NTPCFOMDevice;
#endif
};



#endif			// __NTPCFOMDriver_h__
