/*
 ******************************* Creazione file *******************************
 *-------------------------------------|--------------------------------------*
 * Creatore : Marco Savegnago					Data di creazione : 30/03/2000
 * Codice   :
 *
 * Note:
 *
 *
 ******************************* Revisione file *******************************
 *-------------------------------------|--------------------------------------*
 * Revisore :                                  Data di revisione :
 * Versione : 0
 *
 * Note:
 *
 */


#include <vdw.h>
#include <ntddk.h>
#include "NTPCFOMDriver.h"
#include "NTPCFOMDevice.h"


PCCIO_FR_STR::PCCIO_FR_STR(UCHAR by_Cmd, USHORT	w_Arg, USHORT w_Size, PUCHAR pby_Data)
:
	by_cmd(by_Cmd),
	w_arg(w_Arg),
	w_size(w_Size),
	pby_data(pby_Data),
	b_ownData(FALSE)
{
	if(w_size>0 && pby_data==NULL)
	{
		b_ownData	=	TRUE;
		pby_data	=	new	UCHAR[w_size];
	}

/*
	if(w_Size)
	{
		pby_data	=	new	UCHAR[w_Size];

		if(pby_data!=NULL)
		{
			if(pby_Data)
				memcpy(pby_data, pby_Data, w_Size);
		}
	}
*/
}

PCCIO_FR_STR::~PCCIO_FR_STR()
{
	if(b_ownData)
		delete[]	pby_data;

/*
	if(pby_data!=NULL)
		delete[]	pby_data;
*/
}

USHORT PCCIO_FR_STR::Checksum()
{
	NTSTATUS 	status;
	USHORT		w_checkSum  = 0;
	USHORT		_w_size 	= 0;
	UCHAR* 		_pby_data;

// Calcolo il checkSum dell'header del frame.
	w_checkSum = HeaderChecksum();

// Calcolo il checkSum del campo data del frame.
	_w_size   = w_size;
	_pby_data = pby_data;

// Se c'e' il campo data.
	if(_pby_data)
	{
		for(;_w_size;_w_size--)
		{
			w_checkSum += *_pby_data;
			_pby_data++;
		}
	}

	return(w_checkSum);
}

USHORT PCCIO_FR_STR::HeaderChecksum()
{
	USHORT  w_checkSum;

// Calcolo il checkSum dell'header del frame.
	w_checkSum  = by_cmd; // Comando
	w_checkSum += w_arg;  // Argomento.
	w_checkSum += w_size; // Dimensione del campo data.

	return(w_checkSum);
}
